#include "duplink.h"

// Markiert Attr mit ReparsePoint
// Voraussetzung: list ist nach Dateigre sortiert; auf- oder absteigend unwichtig.
unsigned markDup(FileTree**list,unsigned len) {
 unsigned count = 0;
 ULONGLONG fsize = 0;	// (vorhergehende) Dateigre
 HANDLE h0 = INVALID_HANDLE_VALUE;	// Dateihandle
 HANDLE m0 = 0;		// Map-Handle
 const void*c0 = 0;	// Datenzeiger
// BUG: Dateien gleicher Gre mssen untereinander (jeder mit jedem) verglichen werden.
// Hier wird vereinfachend nur mit der ersten Datei verglichen.
 for (unsigned i=0; i<len; i++) {
  FileTree*item = list[i];
  if (fsize!=item->Size) {
   if (c0 && !UnmapViewOfFile(c0)) DebugBreak(); c0=0;
   if (m0 && !CloseHandle(m0)) DebugBreak(); m0=0;
   if (h0!=INVALID_HANDLE_VALUE && !CloseHandle(h0)) DebugBreak(); h0=INVALID_HANDLE_VALUE;
   fsize=item->Size;	// Erste Datei eines Sets
  }else if (!c0) {
   h0 = CreateFile(list[i-1]->path,GENERIC_READ,0,NULL,OPEN_EXISTING,0,0);
   if (h0!=INVALID_HANDLE_VALUE) {
    m0 = CreateFileMapping(h0,NULL,PAGE_READONLY,0,0,NULL);
    if (m0) c0 = MapViewOfFile(m0,FILE_MAP_READ,0,0,0);
   }
  }
  if (c0) {	// Die erste Datei gleicher Gre ist gemappt?
   HANDLE h = CreateFile(item->path,GENERIC_READ,0,NULL,OPEN_EXISTING,0,0);
   if (h!=INVALID_HANDLE_VALUE) {
    HANDLE m = CreateFileMapping(h,NULL,PAGE_READONLY,0,0,NULL);
    if (m) {
     const void*c = MapViewOfFile(m,FILE_MAP_READ,0,0,0);
     if (c) {
      if (!memcmp(c0,c,(size_t)fsize)) {
       item->Attr|=FILE_ATTRIBUTE_REPARSE_POINT;
       count++;
       FileTree::c.equals++;
       FileTree::c.equalBytes+=fsize;
      }
      if (!UnmapViewOfFile(c)) DebugBreak();
     }
     if (!CloseHandle(m)) DebugBreak();
    }
    if (!CloseHandle(h)) DebugBreak();
   }
  }
 }
 if (c0 && !UnmapViewOfFile(c0)) DebugBreak();
 if (m0 && !CloseHandle(m0)) DebugBreak();
 if (h0!=INVALID_HANDLE_VALUE && !CloseHandle(h0)) DebugBreak();
 return count;
}

unsigned linkDup(FileTree**list,unsigned len) {
 FileTree*ref=0;
 for (unsigned i=0; i<len; i++) {
  FileTree*item=list[i];
  if (item->Attr&FILE_ATTRIBUTE_REPARSE_POINT) {
   TCHAR verweis[MAX_PATH];
   PathRelativePathTo(verweis,item->path,0,ref->path,0);
// 2 = SYMBOLIC_LINK_FLAG_ALLOW_UNPRIVILEGED_CREATE
   static bool gingschonmal;
   if (gingschonmal) {
    if (DeleteFile(item->path)) {
     if (!CreateSymbolicLink(item->path,verweis,2)) println(T("Link ging schief, %d"),GetLastError());;
    }else println(T("Lschen ging schief, %d"),GetLastError());
   }else{
    println(T("Aktion: %s => %s"),item->path,verweis);
    TCHAR temp[MAX_PATH];
    lstrcpy(temp,item->path);
    lstrcpy(PathFindFileName(temp),T("$lnk$.tmp"));
    if (CreateSymbolicLink(temp,verweis,2)) {
     if (DeleteFile(item->path)) {
      if (MoveFile(temp,item->path)) gingschonmal=true;
      else println(T("Umbenennen ging schief!, %d"),GetLastError());;
     }else println(T("Lschen ging schief, %d"),GetLastError());
    }else println(T("Link ging schief, %d, Entwicklermodus aktivieren oder als Administrator laufen lassen!"),GetLastError());;
   }
   if (!gingschonmal) return 1;
  }else ref=item;
 }
 return 0;
}
